Package: org.codehaus.groovy.ast.expr

## [Java] Class Expression

- org.codehaus.groovy.ast.expr.Expression

- Represents a base class for expressions which evaluate as an object

  Authors:
    James Strachan

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `ClassNode` | `getType()`
    `` | `void` | `setType(ClassNode t)`
    `` | `Expression` | `transformExpression(ExpressionTransformer transformer)` Return a copy of the expression calling the transformer on any nested expressions
    `` | `protected List<Expression>` | `transformExpressions(List<? extends Expression> expressions, ExpressionTransformer transformer)` Transforms the list of expressions
    `<T extends Expression>` | `protected List<T>` | `transformExpressions(List<? extends Expression> expressions, ExpressionTransformer transformer, Class<T> transformedType)` Transforms the list of expressions, and checks that all transformed expressions have the given type.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class AnnotatedNode` | `addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`
    `class ASTNode` | `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getNodeMetaData, getNodeMetaData, getText, putNodeMetaData, removeNodeMetaData, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setNodeMetaData, setSourcePosition, visit`
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### public ClassNode getType()

    - #### public void setType(ClassNode t)

    - #### public Expression transformExpression(ExpressionTransformer transformer)

      Return a copy of the expression calling the transformer on any nested expressions

      Parameters:
        transformer

    - #### protected List<Expression> transformExpressions(List<? extends Expression> expressions, ExpressionTransformer transformer)

      Transforms the list of expressions

      Returns:
        a new list of transformed expressions

    - #### <T extends Expression> protected List<T> transformExpressions(List<? extends Expression> expressions, ExpressionTransformer transformer, Class<T> transformedType)

      Transforms the list of expressions, and checks that all transformed expressions have the given type.

      Returns:
        a new list of transformed expressions